Turbine.Chat.Received = function(sender,args)
    if args.ChatType == Turbine.ChatType.EnemyCombat  then
        local cleanedMessage = string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1")
        local source,_,skillName,_ = string.match(cleanedMessage,"^(.*) scored a (.*)hit with (.*) on (.*)%.$")
        if skillName == "Steadfast Barrage" then
            BarrageTimers:NewTimer(30, source, source, true, false, false, BarrageIcon)
        end
        --BarrageTimers:NewTimer(30, "Test", "Test", true, false, false, BarrageIcon)
    end
end

function MoveWindow()
    BarrageTimers:ToggleMove();
    Immunities:ToggleMove()
end

function SetCommands()
    Command = Turbine.ShellCommand()

    function Command:Execute( _, command )
        if command ~= nil or string.len( command ) ~= 0 then
            if command == "move" then
                MoveWindow()
            elseif command == "lock" then
                MoveWindow()
            else
                ChatOutput( "Non-existing command" )
            end
        end
    end
    
    Turbine.Shell.AddCommand( "primePvP", Command )
end