
E = {}

-- All effect added alerts {duration, message, iconInitial, icon, countdown, soundeffect}
E.EffectsAdded = {
    --["Hemorrhage - 3"] = {10, "Applied hemorrhage tier 3, swap aggro", false, false},
    ["Immolated"] = {3, Wounds, CureIcon, false, SoundEffects["Beepq"]},
    ["Lingering Frost"] = {2, "Puddle!", PuddleIcon, false, SoundEffects["Horn"]}, -- TG puddles
    --["Dread"] = {10, "Test", false, false},
    
    -- Harrowing
    ["Flaming Pitch"] = {5, Puddle, PuddleIcon, true, SoundEffects["Beepq"]},
    ["Volley"] = {5, "Dropping volley aoe", PuddleIcon, true, SoundEffects["Beepq"]},
    
    -- Roost
    ["Carrying a fell beast egg"] = {10, "You better YEET that egg quickly!", false, false, nil},
    ["Acid Puddles"] = {15, Puddles, PuddleIcon, true, nil},
    
    -- Anvil
    ["Flight"] = {45, "PURPLE EYE!", PurpleEye, true, SoundEffects["Run"]},
    ["Clinging Frost"] = {60, "Ice drake debuff care",  true, SoundEffects["Alarmq"]},
    ["Vethúg's Revenge"] = {15, Puddle, PuddleIcon, true, SoundEffects["Horn"]},
    ["Frozen Solid"] = {30, "Frozen", true, SoundEffects["Beeps"]},
    
    -- Black Lore
    ["Brewing Storm"] = {3, "Use horn!", false, SoundEffects["Alarms"]}, -- Nurzum
    ["Scorching Rage"] = {15, "Dropping puddle", PuddleIcon, true, SoundEffects["Horns"]}, --Black lore final boss
    ["Blind Hatred"] = {4, "Green eye!", PurpleEye, false, SoundEffects["Alarm"]},
    
    -- Turingwraith 
    ["Shadow of Doubt"] = {9, "Dropping puddle", PuddleIcon, true, SoundEffects["Doubleq"]}, 
    ["Blood-burst"] = {9, "Aura!", true, SoundEffects["Doubleq"]},
    
    -- Kings
    ["Encroaching Darkness"] = {10, "Dropping puddle!", PuddleIcon, true, SoundEffects["Hornq"]}, -- Black blade
    ["Touch of Sorcery"] = {11, "Aoe eye!", PurpleEye, true, SoundEffects["Doubleq"]}, --Throne aoe eye
    ["Deepening Gloom"] = {2, "Puddle!", PuddleIcon, false, SoundEffects["Doubleq"]}, --Gloom puddle
    ["Gloom"] = {10, "Puddle!", PurpleEye, true, SoundEffects["Horns"]}, -- Gloom puddle dot
    ["Disregarded"] = {10, "Threat Wipe!", AlertIcon, true, SoundEffects["AHorn"]}, -- Witch king + filth
    ["Spreading Fear"] = {7, "Dropping aoe", PurpleEye, true, SoundEffects["Hornq"]},
    
    -- PVMP
    ["Blight"] = {3,"Blight", PuddleIcon, false, SoundEffects["Beepq"]}, -- defiler
    ["Inspiriting Presence"] = {10, "Cappy crit", nil, true, SoundEffects["Amazing"]},
    
    -- Remmorchant
    ["Arcing Lightning"] = {15, "Lightning!", AlertIcon, true, SoundEffects["Beepq"]},
    ["Sticky Venom"] = {30, "DO NOT POT", AlertIcon, true, SoundEffects["Beepq"]},
    ["Fiery Combustion"] = {15, "Move out of the group!", AlertIcon, true, SoundEffects["Hornq"]},
    ["Acidic Webs"] = {3, "Move out of web", AlertIcon, false, SoundEffects["Alarmq"]},
    ["Deliquesce"] = {3, "Puddle!", AlertIcon, false, SoundEffects["Alarmq"]},
    ["Acidic Ichor"] = {3, "Puddle!", false, SoundEffects["Alarmq"]},
    ["Corrosive Spittle"] = {3, "Puddle!", false, SoundEffects["Alarmq"]},
    ["Necrotic Ooze"] = {30, "Drain shield", nil, true, nil},
    ["Hail of Webs"] = {6, "Remove outside of group!", AlertIcon,  false, SoundEffects["Alarmq"]},
    ["Smouldering Wrath"] = {15, "Wrath on you", CureIcon, true, nil},
    ["Dripping Ichor"] = {15, "Puddle on you!", CureIcon, true, SoundEffects["Alarmq"]},
    ["Parasites"] = {15, "Parasites on you!", AlertIcon, true, nil},
    ["Stung!"] = {4, "Remove disease!", true, false, SoundEffects["Alarmq"]},

    -- Rift
    ["Cave In"] = {3, "Move out of Cave In", true, false, SoundEffects["AlarmQ"]},
    ["Melted Armour"] = {3, "Remove wound!", false, false, SoundEffects["Alarmq"]},
    ["Mortal Wound"] = {3, "Remove wound!", false, false, SoundEffects["Alarmq"]},
    --["Melted Armour"] = {3, "Remove wound!", false, false, SoundEffects["Alarmq"]}, miss fear
    --["Melted Armour"] = {3, "Remove wound!", false, false, SoundEffects["Alarmq"]}, thaurlauch fear
    ["Fatal Affliction"] = {3, "Cure poison!", false, false, SoundEffects["Alarmq"]},
    ["Blinding Dark"] = {3, "Remove fear!", false, false, SoundEffects["Alarmq"]},
    ["Marked Prey"] = {3, "Remove fear!", false, false, SoundEffects["Alarmq"]},

    -- DN
    ["Poisoned Ground"] = {3, "Move out!", false, false, SoundEffects["Hornq"]},
    ["Killing Field"] = {3, "Move out!", false, false, SoundEffects["Hornq"]},
    ["Fighter's Bane"] = {3, "Kill Limrafn", false, false, nil},
    ["Defender's Bane"] = {3, "Kill Limrafn", false, false, nil},
    ["Caster's Bane"] = {3, "Kill Limrafn", false, false, nil},
    ["Impending Mark: Flâgît's Ire"] = {6, "Move out of room!", true, true, SoundEffects["Hornq"]},
    ["Mark: Flâgît's Ire"] = {10, "You done fucked up A A ron", true, true, SoundEffects["Hornq"]},
    ["Disintegration"] = {3, "Move out!", false, false, SoundEffects["Hornq"]},
    ["Impending Poison"] = {3, "Cure!", false, false, SoundEffects["Hornq"]},
    ["Suppressing Shadows"] = {5, "Move out!", false, false, SoundEffects["Hornq"]},
    ["Shattered Armour"] = {3, "Cure Wound!", true, false, SoundEffects["Hornq"]},
    --["Water-lore"] = {15, "Parasites on you!", true, true, nil},

    ["Rowdy Crowd"] = {30, "Move Out!", true, false, nil, true, nil},
}-- All effect added alerts {duration, message, iconInitial, icon, countdown, soundeffect}

RemovedBasicPlayerEffectsSelf = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeRemovedPlayerEffectsSelf")
AddedCharPlayerEffectsSelf = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeAddedPlayerEffectsSelf")

if AddedCharPlayerEffectsSelf ~= nil then
    for key, value in pairs(AddedCharPlayerEffectsSelf) do
        E.EffectsAdded[key] = value
    end
else
    AddedCharPlayerEffectsSelf = {}
end

if RemovedBasicPlayerEffectsSelf ~= nil then
    for key, _ in pairs(RemovedBasicPlayerEffectsSelf) do
        E.EffectsAdded[key] = nil
    end
else
    RemovedBasicPlayerEffectsSelf= {}
end

-- [1] Duration [2] Message [3] Icon (Special/Game/None) [4] Countdown [5] SoundEffect [6] TargetBox popup [7] TargetBox Icon
E.AllEffectsAdded = {
    ["Crushing Roots"] = {4, "Root dot on: ", true, false, SoundEffects["Beeps"], true, HealIcon}, -- Thuringwaith tree dot
    ["Flight"] = {45, "Purple eye on: ", PurpleEyeSmall, true, nil, false, nil}, -- Anvil eye
    ["Vethúg's Revenge"] = {15, "Dot on: ", true, true, nil, true, true}, -- Anvil dot
    ["Clinging Frost"] = {4, "Frost debuff on: ", nil, true, SoundEffects["Doubleq"], false, nil}, -- Anvil debuff
    ["Frozen Solid"] = {4, "Frozen: ", nil, true, nil, false, nil}, -- Anvil frozen
    ["Scorching Rage"] = {15, "Dot on: ", PuddleIconSmall, true, SoundEffects["Doubleq"], true, true}, -- Black lore dot
    ["Blood-burst"] = {9, "Aura on: ", true, true, SoundEffects["Doubleq"], true, true}, -- Thuringwaith aura
    ["Touch of Sorcery"] = {11, "Aoe on: ", PurpleEyeSmall, true, SoundEffects["Doubleq"], false, nil}, --Throne aoe eye
    ["Shadow of Doubt"] = {9, "Puddle on: ", PuddleIconSmall, true, nil, false, nil}, --Thuringwraith puddle fear
    ["Encroaching Darkness"] = {4, "Puddle on: ", PuddleIconSmall, false, nil, false, nil}, -- Black blade
    ["Spreading Fear"] = {7, "Aoe on: ", PurpleEyeSmall, true, nil, false, nil},
    ["Gloom"] = {10, "Puddle on: ", PurpleEyeSmall, true, SoundEffects["Doulbeq"], false, nil},
    ["Non-Threatening"] = {5, "Threat wipe on: ", AlertIconSmall, true, SoundEffects["Doubleq"], false, nil},
    ["Hideous Venom"] = {3, "DoT on: ", AlertIconSmall, false, nil, true, true},
    ["Creeping Cold"] = {3, "DoT on: ", AlertIconSmall, false, nil, true, true},
    ["Spiteful Words"] = {3, "DoT on: ", AlertIconSmall, false, SoundEffects["Alarmq"], true, true},
    ["Blind Hatred"] = {4, "Green eye on: ", PurpleEyeSmall, false, SoundEffects["Alarmq"], true, true},
    ["Arcing Lightning"] = {15, "Lightning on: ", true, true, nil, false, nil},
    ["Sticky Venom"] = {30, "Venom on: ", AlertIconSmall, true, nil, false, nil},
    ["Fiery Combustion"] = {15, "Fiery Combustion on: ", true, true, nil, true, true},
    ["Fixated"] = {45, "Fixated on: ", AlertIconSmall, true, nil, true, true},
    ["Life Drain"] = {8, "Life Drain on: ", BloodBoilIcon, true, nil, true, BloodBoilIcon},
    ["Shadow-spun Webs"] = {8, "Binding webs on: ", WebIcon, false, nil, false, nil},
    --["Hail of Webs"] = {6, "Webs on: ", AlertIconSmall,  false, nil},
    ["Smouldering Wrath"] = {15, "Wrath on: ", true, true, nil, true, true},
    ["Dripping Ichor"] = {15, "Puddle on: ", true, true, nil, false, nil},
    ["Parasites"] = {15, "Parasites on: ", true, true, nil, true, true},
    --["Mending Verse"] = {15, "Test", AlertIconSmall, true, nil},
    --["Daughter's Phermones"] = {65, "Daughter's Phermones on: ", AlertIconSmall, true, nil},
    --["Thossulun's Phermones"] = {65, "Daughter's Phermones on: ", AlertIconSmall, true, nil}
    --["Water-lore"] = {4, "Water-lore on: ", true, true, nil},

    -- Rift
    ["Sapping Disease"] = {3, "Cure disease on: ", true, false, nil, true, true},

    -- DN
    ["Virulent Contagion"] = {4, "Move away from: ", true, false, nil, false, nil},
    ["Paralyzing Contagion"] = {4, "Move away from: ", true, false, nil, false, nil},
    ["Impending Mark: Flâgît's Ire"] = {6, "Eye on: ", true, true, nil, false, nil},
    ["Mark: Flâgît's Ire"] = {10, "Mark on: ", true, true, nil, false, nil},
    ["Deadly Poison"] = {3, "Poison on: ", true, false, nil, true, true},
    ["Major Disease"] = {3, "Disease on: ", true, false, nil, true, true},
    ["Major Wound"] = {3, "Wound on: ", true, false, nil, true, true},
    ["Mortal Terror"] = {3, "Fear on: ", true, false, nil, true, true},
    ["Mark: Flâgît's Ire"] = {3, "Mark on: ", true, false, nil, false, nil},

    --PvMP
    ["Field Promotion"] = {4, "Bubble on: ", true, false, nil, false, nil},
    ["Grievous Wounds"] = {5, "Grave wound on: ", true, true, nil, true, true},
    ["Oathbreaker's Shame"] = {20, "OB on: ", true, true, nil, true, true},
    ["Heart Seeker"] = {8, "HS on: ", true, true, nil, true, true},
    ["Essence of Winter"] = {5, "Essence of Winter on: ", true, false, nil, false, nil},
    --["Telling Mark"] = {3, "Telling Mark on: ", nil, false, nil},
    --["Blessing of Darkness"] = {4, "Blessing on: ", nil, false, nil},
    ["Ancient Craft"] = {5, "AC on: ", true, false, nil, true, true},
    ["Shadow Vortex"] = {10, "Vortex on: ", true, true, nil, false, nil},
    ["Impending End"] = {20, "Free: ", true, true, nil, false, nil},

    ["Rowdy Crowd"] = {30, "Volleys on: ", true, true, nil, false, nil},
}
-- [1] Duration [2] Message [3] Icon (Special/Game/None) [4] Countdown [5] SoundEffect [6] TargetBox popup [7] TargetBox Icon

RemovedBasicPlayerEffectsAll = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeRemovedPlayerEffectsAll")
AddedCharPlayerEffectsAll = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeAddedPlayerEffectsAll")

if AddedCharPlayerEffectsAll ~= nil then
    for key, value in pairs(AddedCharPlayerEffectsAll) do
        E.AllEffectsAdded[key] = value
    end
else
    AddedCharPlayerEffectsAll = {}
end

if RemovedBasicPlayerEffectsAll ~= nil then
    for key, _ in pairs(RemovedBasicPlayerEffectsAll) do
        E.AllEffectsAdded[key] = nil
    end
else
    RemovedBasicPlayerEffectsAll= {}
end

-- Self buffs only
-- [1] duration [2] name [3] unique [4] activity timer [5] show activity
E.SelfOnlyEffects = {
    ["Inspiriting Presence"] = {30, "Cappy crit", false, 10, true},
}

-- Self buffs only
-- [1] duration [2] name [3] unique [4] activity timer [5] show activity
EBeorning = {
    ["Nature's Bond"] = {120, "Nature's Bond", true, 20, true},
    ["Thickened Hide"] = {120, "TH", false, true, true},
    ["Aid the Assault"] = {38.5, "Maul", false, 8.5, true}
}
EBurglar = {}
ECaptain = {
    --["Last Stand"] = {300 , "Last Stand (Max)", false, nil},
    ["Last Stand"] = {75 , "LS (Min)", false, 17, true},
    ["In Harm's Way"] = {180, "IHW", true, 15, true},
    ["Fighting Withdrawal"] = {60, "Withdrawal", true, 20, true},
    ["Cry of Vengeance"] = {300, "Captain rez", true, nil, nil},
}
EChampion = {
    --["Champion's Duel 1"] = {60, "Champs duel", false}
}
EGuardian = {
    ["Warrior's Heart"] = {120, "WH", true, 20, true},
    ["Guardian's Pledge"] = {120, "Pledge", false, 15, true},
    ["Juggernaut"] = {180, "Juggernaut", true, 15, true},
    ["Bring on the Pain"] = {60, "TOD", false, 10, true},
    ["Litany of Defiance"] = {90, "Litany", false, 20, true},
}
EHunter = {}
ELoreMaster = {}
EMinstrel = {
    ["Recovering Spirit"] = {45, "Triumphant Spirit", false, nil},
    ["Fellowship's Heart"] = {120, "Fellowship's Heart", true, nil},
    ["Legend of the Hammerhand"] = {120, "AOE Mini bubble", true, nil}
}
ERuneKeeper = {
    ["Our Fates Entwined"] = {90, "Fates", true, 20, true},
}
EWarden = {}
EBlackArrow = {
    ["Moving Target"] = {90, "MT", true, true, true}
}
EDefiler = {
    ["Blessing of Darkness"] = {80, "Blessing", true, nil}
}
EReaver = {}
EStalker = {
    ["Sprint"] = {90, "Sprint", false, true, true},
    ["Improved Stealth"] = {210, "Dissappear", false, true, true}
}
EWarleader = {}
EWeaver = {
    ["Toxic Carapace"] = {60, "Reflect", false, true, true}
}


E.PlayerEffects = {
    [Turbine.Gameplay.Class.Beorning] = EBeorning,
    [Turbine.Gameplay.Class.Burglar] = EBurglar,
    [Turbine.Gameplay.Class.Captain] = ECaptain,
    [Turbine.Gameplay.Class.Champion] = EChampion,
    [Turbine.Gameplay.Class.Guardian] = EGuardian,
    [Turbine.Gameplay.Class.Hunter] = EHunter,
    [Turbine.Gameplay.Class.LoreMaster] = ELoreMaster,
    [Turbine.Gameplay.Class.Minstrel] = EMinstrel,
    [Turbine.Gameplay.Class.RuneKeeper] = ERuneKeeper,
    [Turbine.Gameplay.Class.Warden] = EWarden,
    [Turbine.Gameplay.Class.BlackArrow] = EBlackArrow,
    [Turbine.Gameplay.Class.Defiler] = EDefiler,
    [Turbine.Gameplay.Class.Reaver] = EReaver,
    [Turbine.Gameplay.Class.Stalker] = EStalker,
    [Turbine.Gameplay.Class.WarLeader] = EWarleader,
    [Turbine.Gameplay.Class.Weaver] = EWeaver
}

RemovedBasicSkillTimersSpecific = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeRemovedSkillTimersSpecific")
AddedCharSkillTimersSpecific = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeAddedSkillTimersSpecific")

if AddedCharSkillTimersSpecific ~= nil then
    for key, value in pairs(AddedCharSkillTimersSpecific) do
        E.PlayerEffects[ClassnameToObject[value[6]]][key] = {value[1], value[2], value[3], value[4], value[5]}
    end
else
    AddedCharSkillTimersSpecific = {}
end

if RemovedBasicSkillTimersSpecific ~= nil then
    for key, _ in pairs(RemovedBasicSkillTimersSpecific) do
        for _, value in pairs(E.PlayerEffects) do
            for _, timer in pairs(value) do
                value[key] = nil
            end
        end
    end
else
    RemovedBasicSkillTimersSpecific= {}
end


E.AllPlayerEffects = {
    -- Beorning Group Buffs
    ["Sacrifice"] = {60, "Sacrifice (Min)", false, 20, true},
    -- Cappy Group Buffs
    ["Standard of Valour Incoming Healing Buff"] = {60, "Banner", true, 30, true},
    ["Standard of War Damage Buff"] = {60, "Banner", true, 30, true},
    ["Standard of Honour"] = {60, "Banner", true, 30, true},
    -- RuneKeeper group buffs
    ["Essay of Exaltation"] = {45, "AOE RK Bubble", true, nil},
    --["Word of Exaltation"] = {45, "AOE RK Bubble", true, nil},
    ["Shield of the Dúnedain"] = {120 , "SoD", false, true, true},
    -- PvMP
    ["Field Promotion"] = {120, "Bubble", false, true, true},
    --["Parasites"] = {40, "Parasites", false, nil, false},

    -- Test
    --["Mending Verse"] = {15, "Test", false, true, true},
    --["Water-lore"] = {39, "Test", false, true, true},
    --["Temporary State Immunity"] = {20, "Test", false, true, true},
}

RemovedBasicSkillTimersAll = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeRemovedSkillTimersAll")
AddedCharSkillTimersAll = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeAddedSkillTimersAll")

if AddedCharSkillTimersAll ~= nil then
    for key, value in pairs(AddedCharSkillTimersAll) do
        E.AllPlayerEffects[key] = {value[1], value[2], value[3], value[4], value[5]}
    end
else
    AddedCharSkillTimersAll = {}
end

if RemovedBasicSkillTimersAll ~= nil then
    for key, _ in pairs(RemovedBasicSkillTimersAll) do
        E.AllPlayerEffects[key] = nil
    end
else
    RemovedBasicSkillTimersAll= {}
end


-- [1] duration [2] alert [3] icon [3] icon (true/false)
E.SkillNames = {
    --["Gaze of Sauron"] = {4, "Purple eye!", PurpleEyeSmall, true}
    ["Shadow Force"] = {45, "AoE CD", nil, true},
    ["Bursting Flame"] = {3, "Move in melee range!", nil, false},
    ["Baleful Roar"] = {3, "Check for hope", nil, false},
    ["Bone Grind"] = {3, "Move out of Bone Grind", nil, false},
    ["Cave In"] = {3, "Move out of Cave In", nil, false},
    ["Poisoned Ground"] = {2, "Move out!", nil, false},
    ["Killing Field"] = {2, "Move out!", nil, false},
    ["Disintegration"] = {2, "Move out!", nil, false},
    ["Whirlwind"] = {2, "Move out!", nil, false},
    ["Withering Strike"] = {3, "Don't forget to interrupt!", nil, false},
    ["Stinger Thrust"] = {3, "Stinger Thrust!", nil, false}
}

E.SkillAlertNames = {
}

E.UniqueEffects = {
    ["Necrotic Ooze"] = true
}

E.GroupEffectsActive = {
    ["Standard of Valour Incoming Healing Buff"] = true,
    ["Standard of War Damage Buff"] = true,
    ["Standard of Honour"] = true,
    ["Our Fates Entwined"] = true,
}

E.GroupEffectsCooldown = {
    ["Standard of Valour Incoming Healing Buff"] = true,
    ["Standard of War Damage Buff"] = true,
    ["Standard of Honour"] = true,
    ["Our Fates Entwined"] = true,

    ["Sacrifice"] = true,
    ["Essay of Exaltation"] = true,
    ["Shield of the Dúnedain"] =true,
    ["Field Promotion"] = true,
    ["Legend of the Hammerhand"] = true,
    ["Fellowship's Heart"] = true,
    ["Nature's Bond"] = true,



    --["Mending Verse"] = true,


}

E.BetterEffectIcons = {
    ["Our Fates Entwined"] = 1091829845,
    ["Essay of Exaltation"] = 1091829850,

    ["Juggernaut"] = 1091805299,
    ["Litany of Defiance"] = 1091444826,
    ["Bring on the Pain"] = 1090541184,

    ["In Harm's Way"]  = 1091926677,

    ["Recovering Spirit"] = 1091810072,
    ["Legend of the Hammerhand"] = 1091830292,


}

TargetWindowEffects = {  
    -- Test
    --["Defiant Challenge"] = "Test message",
    --["Conviction"] = "Test message",
    --["In the Fray"] = true,
    --["Assailment"] = true,
    --["Man-form"] = true,
    --["Hearten"] = true,
    --["Blood of Fire"] = true,
    --["Mending Verse"] = true,
    --
    -- Shelob
    ["Pained Determination"] = true,
    --["Wilful Determination"] = "Phial",

    -- Thossulun
    ["Penetrated Shell"] = true,

    -- Shadowed King
    ["Shadow's Protection"] = true,
    ["Crushed"] = true,

    -- Rift
    ["Vulnerable"] = true,

    -- DN
    ["Vigor"] = true,
    ["Frenzy"] = true,

    -- Class Freep
    ["Ancient Craft"] = true,
    ["Oathbreaker's Shame"] = true,
    ["Oaths Fulfilled"] = true,
    ["Grievous Wounds"] = true,
    ["Moving Target"] = true,
    ["Field Promotion"] = true,
    ["Knives Out"] = true,
    ["Shield of the Dúnedain"] = true,
    ["Last Stand"] = true,
    ["Our Fates Entwined"] = true,
    ["Subtle Stab"] = true,
    ["Do Not Fall This Day"] = true,
    ["Clinging Webs"] = true,
    ["Entangling Web"] = true,
    ["Venomous Haze"] = true,
    ["Essence of Winter"] = true,

    -- Class Creep
    ["Toxic Carapace"] = true,
    ["Sprint"] = true,
    ["Blight"] = true,
    ["Festering Wound"] = true,
    ["Blessing of Darkness"] = true,
    --["Blinding Dust"] = true,
    ["Sundering Blow"] = true,
    ["Hamstrung"] = true,
    ["Blade Toss"] = true,
    ["Devastating Strike"] = true,


    -- CC immunities
    ["Daze and Stun Immunity"] = true,
    ["Root Immunity"] = true,
    ["Fear Immunity"] = true,
    ["Immunity"] = true,
    ["Temporary State Immunity"] = true,
    ["Continuous Blood Rage"] = true,
    ["Juggernaut"] = true,
    ["Tactically Sound"] = true,

    --PVP Server
    ["Invulnerable"] = true,
    --["Fire"]
}

SetEffects = function()
    local PlayerClass = Player:GetClass() 
    -- Freeps
    if PlayerClass == Turbine.Gameplay.Class.Beorning then
        TargetWindowEffects["Defensive Blow"] = true
        TargetWindowEffects["Debilitating Bees"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.Burglar then
        TargetWindowEffects["Reveal Weakness"] = true 
    elseif PlayerClass == Turbine.Gameplay.Class.Captain then
        TargetWindowEffects["Armour Rend"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.Guardian then
        TargetWindowEffects["Fire-lore"] = true
        TargetWindowEffects["Frost-lore"] = true
        --TargetWindowEffects["Disable"]
    elseif PlayerClass == Turbine.Gameplay.Class.LoreMaster then
        TargetWindowEffects["Fire-lore"] = true
        TargetWindowEffects["Frost-lore"] = true
        TargetWindowEffects["Shatter Arms"] = true
        TargetWindowEffects["Ranged Critical Chance"] = true
        TargetWindowEffects["Nature's Light"] = true
        TargetWindowEffects["Benediction of the Raven"] = true
        TargetWindowEffects["Charged Air"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper then
        TargetWindowEffects["Writ of Lightning"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.Warden then
        TargetWindowEffects["Low Bleed - Quick Sweep"] = true
        TargetWindowEffects["Medium Bleed - Quick Sweep"] = true
        TargetWindowEffects["Marked Target"] = true
        TargetWindowEffects["Diminished Target"] = true
        TargetWindowEffects["Hampering Javelin"] = true
    -- Creeps
    elseif PlayerClass == Turbine.Gameplay.Class.BlackArrow then
        TargetWindowEffects["Hindering Shot"] = true
    end
end

StackingTargetEffects = {
    -- Rukhor
    ["Blood-Infused - "] = 10,
    ["Blood Drain - "] = 10,
    -- Shelob
    ["Impenetrable Webs - "] = 120,
    -- Guruthang of the Queensbrood.
    ["Elusive - "] = 5,
    --["Coward's Fate "] = 5,
}

for key, value in pairs(StackingTargetEffects) do
    for i = 1, value do 
        TargetWindowEffects[key .. i] = true
    end
end

RemovedBasicEffects = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeRemovedTargetEffects")
AddedCharEffects = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeAddedTargetEffects")

if AddedCharEffects ~= nil then
    for key, _ in pairs(AddedCharEffects) do
        TargetWindowEffects[key] = true
    end
else
    AddedCharEffects = {}
end

if RemovedBasicEffects ~= nil then
    for key, _ in pairs(RemovedBasicEffects) do
        TargetWindowEffects[key] = nil
    end
else
    RemovedBasicEffects = {}
end



function AddTableToTable(table1, table2)
    for key, _ in pairs(table1) do
        table2[key] = true
    end
end

GroupEffectsLUT = {}
SelfEffectsLUT = {}

-- Get all effects in one table

ReadyCheckTable = {
    ["Duty Bound"] = true,
    ["Ironfold Edhelharn Token: Give Hope"] = true,
    ["Ironfold Edhelharn Token: Give Hope"] = true,
    ["Minas Ithil Warding Lore"] = true,
}

-- Self

AddTableToTable(ReadyCheckTable, SelfEffectsLUT)

if Settings.SPEnabled then
    AddTableToTable(E.AllPlayerEffects, SelfEffectsLUT)
    for key, value in pairs(E.PlayerEffects) do
        AddTableToTable(value, SelfEffectsLUT)
    end
    AddTableToTable(E.SelfOnlyEffects, SelfEffectsLUT)
end

if Settings.SEnabled then
    AddTableToTable(TEffects, SelfEffectsLUT)
end

if Settings.EEnabled then
    AddTableToTable(E.EffectsAdded, SelfEffectsLUT)  
end

if Settings.AEnabled then
    AddTableToTable(E.AllEffectsAdded, SelfEffectsLUT)
end

-- Group
AddTableToTable(ReadyCheckTable, GroupEffectsLUT)

if Settings.AEnabled then
    GroupEffectsLUT["Do Not Fall This Day"] = true
    AddTableToTable(E.AllEffectsAdded, GroupEffectsLUT)
end

if Settings.SPEnabled then
    AddTableToTable(E.AllPlayerEffects, GroupEffectsLUT)
    for key, value in pairs(E.PlayerEffects) do
        AddTableToTable(value, GroupEffectsLUT)
    end
end

if Settings.SEnabled then
    AddTableToTable(TAllEffects, GroupEffectsLUT)
end

-- Collect all damage triggers

DamageLUT = {}

AddTableToTable(TDamage, DamageLUT)
AddTableToTable(E.SkillNames, DamageLUT)
AddTableToTable(E.SkillAlertNames, DamageLUT)
DamageLUT["Steadfast Barrage"] = true

PvPTimerTriggers = {
    ["Steadfast Barrage"] = 30,
    ["Moving Target"] = 90,
    ["Defiant Challenge"] = 30,
    ["Toxic Carapace"] = 60,
    ["Sprint"] = 90,
    ["Trap and Run"] = 30,
}

ShowExpiryEffects = {
    -- PvE

    -- Shelob
    ["Pained Determination"] = true,

    -- Shadowed kings
    ["Shadow's Protection"] = true,
    ["Crushed"] = true,

    -- Freep effects
    ["Oathbreaker's Shame"] = true,
    ["Knives Out"] = true,
    ["Shield of the Dúnedain"] = true,
    ["Last Stand"] = true,

    ["Fire-lore"] = true,
    ["Frost-lore"] = true,
    ["Shatter Arms"] = true,
    ["Ranged Critical Chance"] = true,
    ["Nature's Light"] = true,
    ["Benediction of the Raven"] = true,

    ["Defensive Blow"] = true,
    ["Debilitating Bees"] = true,

    ["Marked Target"] = true,
    ["Diminished Target"] = true,
    ["Hampering Javelin"] = true,

    ["Do Not Fall This Day"] = true,

    -- CC immunities
    ["Daze and Stun Immunity"] = trueG,
    ["Root Immunity"] = true,
    ["Fear Immunity"] = true,
    ["Immunity"] = true,
    ["Temporary State Immunity"] = true,
    ["Continuous Blood Rage"] = true,
    ["Juggernaut"] = true,
    ["Tactically Sound"] = true,

    -- PvP

    -- Creep effects
    ["Moving Target"] = true,
    ["Field Promotion"] = true,
    ["Toxic Carapace"] = true,

    ["Hindering Shot"] = true,
}