InstanceHub = class(Turbine.UI.Control)
function InstanceHub:Constructor()
    Turbine.UI.Control.Constructor(self)
    if Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == 2 then
        Settings.EttenmoorsState = true
        SwitchAction[4]()
    end

    if Settings.EttenmoorsState and Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() < 2 then
        SwitchAction[5]()
    end

    --ChatOutput(Settings.InstanceVersion)
    
    SwitchAction[Settings.InstanceVersion]()
end

function InstanceHub:CheckInstanceState(line)
    if string.find(line, "New Quest: Remmorchant") then
        --  ChatOutput(string.sub(line, string.len( line ), string.len(line)))
        if Settings.EEnabled then
            effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to the Remmorchant! </rgb>",nil,false)
        end
        Settings.InstanceState = true
        Settings.InstanceVersion = 1
        Settings.InstanceTier = string.sub(line, string.len(line), string.len(line))
        SwitchAction[Settings.InstanceVersion]()
    end

    if string.find(line, "New Quest: Amdân Dammul, the Bloody Threshold") then
        if Settings.EEnabled then
            effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to the Bloody Threshold! </rgb>",nil,false)
        end
        Settings.InstanceState = true
        Settings.InstanceVersion = 7
        Settings.InstanceTier = string.sub(line, string.len(line), string.len(line))
        SwitchAction[Settings.InstanceVersion]()
    end

    if string.find(line, "New Quest: The Depths of Kidzul") then
        if Settings.EEnabled then
            effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to Kidzul-kâlah! </rgb>",nil,false)
        end
        Settings.InstanceState = true
        Settings.InstanceVersion = 9
        Settings.InstanceTier = string.sub(line, string.len(line), string.len(line))
        SwitchAction[Settings.InstanceVersion]()
    end

    if string.find(line, "Entered the") then
        if string.find(string.match(line, "Entered the (.*) channel."), "-") and Settings.InstanceVersion > 0 then
            if Settings.EEnabled and Settings.InstanceState then
                --effectsWindow:Message(8, "<rgb=#0008CFF>Leaving so soon?</rgb>",nil,false)
            end
            Settings.InstanceState = false
            Settings.InstanceVersion = 0
            SwitchAction[Settings.InstanceVersion]()
        end


        if not(string.find(line, "Ettenmoors" )) and Settings.EttenmoorsState and Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() < 2 then
            Settings.EttenmoorsState = false
            if KillTracker ~= nil then
                KillTracker:SetVisible(false)
            end
        end

        if combatTimer then
            combatTimer:ChangeMode(false)
        end
    end

    if string.find(line, "Entered the Ettenmoors") and not(Settings.EttenmoorsState) then
        Settings.EttenmoorsState = true
        Settings.InstanceState = false
        if Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == 1 then
            SwitchAction[5]()
        end
    end

    if string.find(line, "resets") then
        -- DG
        if string.find(line, "Dâr Narbugud resets in") then
            Settings.InstanceState = true
            if Settings.EEnabled and Settings.InstanceVersion ~= 2 then
                effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to Dâr Narbugud! </rgb>",nil,false)
            end
            Settings.InstanceVersion = 2
            SwitchAction[Settings.InstanceVersion]()
        end

        -- Rift
        if string.find(line, "The Rift of Nûrz Ghâshu resets in") then
            Settings.InstanceState = true
            if Settings.EEnabled and Settings.InstanceVersion ~= 3 then
                effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to The Rift of Nûrz Ghâshu! </rgb>",nil,false)
            end
            Settings.InstanceVersion = 3
            SwitchAction[Settings.InstanceVersion]()
        end

        -- Throne
        if string.find(line, "Throne of the Dread Terror resets in") then
            Settings.InstanceState = true
            if Settings.EEnabled and Settings.InstanceVersion ~= 8 then
                effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to Throne! </rgb>",nil,false)
            end
            Settings.InstanceVersion = 8
            Settings.InstanceTier = "?"
            SwitchAction[Settings.InstanceVersion]()
        end

    end
end

SwitchAction = {
    -- DefaultState
    [0] = 
    function()

    end,
    -- Remmorchant
    [1] = 
    function()
        fight = FightHandler()
    end,
    -- Dâr Narbugud
    [2] =
    function()
        E.AllEffectsAdded["Gloom"] = nil
        E.EffectsAdded["Gloom"] = nil
    end,
    -- The Rift of Nûrz Ghâshu
    [3] =
    function()

    end,
    -- Ettenmoors Creep
    [4] = 
    function()
        E.EffectsAdded["Smouldering Wrath"] = nil
        E.AllEffectsAdded ["Smouldering Wrath"] = nil
        SwitchAction[6]()
    end,
    -- Ettenmoors Freep
    [5] =
    function()
        SwitchAction[6]()
    end,
    -- Ettenmoors both factions
    [6] =
    function()
        if KillTracker == nil then
            KillTracker = KillCounter()
        else
            KillTracker:SetVisible(true)
        end
    end,
    [7] =
    function()

        fight = FightHandler()
        -- Let's see how they handle bardhrukh, or as my boys call him... THE KILLBEAST! -- Start on boss 1 + X seconds
        --Gorgar the Ruthless says  Look at that! The dwarves killed the Killbeast! -- kill on boss 1
        -- Good warg. To battle! -- Start boss 2
        --The warg chieftain is victorious! I guess you get to live, mongrel! -- Wipe on boss 2
        -- Prince Durin shouts Well done, heroes! -- Kill on boss 2
    end,
    [8] =
    function()
        fight = FightHandler()
    end,
    [9] =
    function()

    end
}

RaidTable = {
    [1] = {
        -- Boss 1
        ["Bratha Tasakh, Lady of Many Venoms"] = {
            ["No, no! I cannot be the last! The Ungoledain will not fall this day!"] = 
            {
                1,
                {
                ["This will not do. Perhaps this may work...."] = {1, 2}
                },
                {
                    ["No! Erk... Felgúr.... You were right.... The Ungoledain die with me...."] = {1, "Bratha Tasakh", true}
                },
                "Bratha Tasakh"
                
            },
        },
        -- Boss 3
        ["Captain Zabothak"] = {

            ["For the Pale Herald!"] = 
            {
                3,
                {
                    ["It is over, Zabothak... and you have failed."] = {3, 2}
                },
                {
                    ["You are... too late...."] = {3, "Zabothak & Rukhor", true}
                },
                "Zabothak & Rukhor"
            }
        },
        -- Boss 4
        ["Legolas"] = {
            ["You must wield the Gilgalar, my friend. Hold off Ungwetári for as long as you can!"] = 
            {
                4,
                nil,
                {
                    ["Ungwetári means to flee! We cannot allow her to escape, my friends!"] = {4, "Shelob", true}
                },
                "Shelob"
            }
        }
    },
    [7] = {
        ["Gorgar the Ruthless"] = {
            -- Boss 1
            ["Let's see how they handle bardhrukh, or as my boys call him... THE KILLBEAST!"] = 
            {
                1, 
                nil,
                {
                    ["Look at that! The dwarves killed the Killbeast!"] = {1, "The Killbeast", true}
                },
                "The Killbeast"
            },

            -- Boss 2
            ["Good warg. To battle!"] = {
                2,
                {
                    ["ENOUGH! I AM NO ONE'S MOUNT!"] = {2, 2}
                },
                {
                    ["The warg chieftain is victorious! I guess you get to live, mongrel!"] = {2, "Gorgar & Ránulur", false},
                    ["Prince Durin shouts Well done, heroes!"] = {2, "Gorgar & Ránulur", true}
                },
                "Gorgar & Ránulur"
            }
        },
    },
    [8] = {
        ["Rakothas"] = {
            -- Boss 1
            ["I am but a hammer before a field of nails!"] = {
                1,
                nil,
                {},
                "Rakothas"
            }
        }
    },
    [9] = {
        ["Gultháva, Maiden of the Gladden"] = {
            -- Boss 1
            ["You must prove you are strong enough to triumph over the shadows below."] = {
                1,
                nil,
                {
                    ["You are indeed strong. Please, help me remove the shadows that corrupt this place."] = {1, "Gultháva", true},
                },
                "Gultháva"
            }
        }
    }
}

FightHandler = class(Turbine.UI.Control)
function FightHandler:Constructor()

    self.InstanceTier = Settings.InstanceTier
    self.InstanceID =  Settings.InstanceVersion

    self.InFight = false

    self.BossID = nil
    self.BossName = nil
    self.PhaseLines = nil
    self.EndLines = nil

    self.CurrentPhase = nil
    self.MaxPhases = nil

    self.StartTime = nil
    self.PhaseStartTime = nil

    self.FightLines = RaidTable[self.InstanceID]
end

function FightHandler:TextUpdate(line)
    local name = GetFirstName(line)
    local cleanedLine = GetTextLine(line)

    --Find if the fight is starting
    if (not(self.InFight) or (self.InFight and not(Player:IsInCombat()))) and self.FightLines[name] and self.FightLines[name][cleanedLine] then
        -- [1] Boss ID [2] Phases lines [3] End Line
        local StartTemp = self.FightLines[name][cleanedLine]
        self.BossID, self.PhaseLines, self.EndLines = StartTemp
        self.BossID = StartTemp[1]
        self.PhaseLines = StartTemp[2]
        self.EndLines = StartTemp[3]
        self.BossName = StartTemp[4]
        self.MaxPhases = tablelength(self.PhaseLines)
        self.StartTime = Turbine.Engine.GetGameTime()
        self.PhaseStartTime = Turbine.Engine.GetGameTime()
        self.InFight = true
        if combatTimer then
            combatTimer:ChangeMode(true)
        end

        return
    end

    -- Return if the fight didn't start and not ongoing
    if not(self.InFight) then return end

    -- We are in a fight

    -- Check for phase ending
    if self.PhaseLines and self.PhaseLines[cleanedLine] then

        -- [1] Boss ID [2] Phase #
        local phaseTemp = self.PhaseLines[cleanedLine]

        if self.BossID == phaseTemp[1] then
            self.CurrentPhase = phaseTemp[2]
            local PhaseDuration = Turbine.Engine.GetGameTime() - self.PhaseStartTime
            ChatOutput("<rgb=#f79000>Completed phase " .. self.CurrentPhase - 1 .. " in " .. TimeDeltaToString(PhaseDuration))
            if Settings.EEnabled then
                effectsWindow:Message(8, "<rgb=#0008CFF>Phase ".. self.CurrentPhase .."</rgb>",nil,false)
            end
            self.PhaseStartTime = Turbine.Engine.GetGameTime()
            return
        end
    end

    -- Check for fight ending
    local detectWipe = ((string.find(line, "Your fellow,") and string.find(line, "has been defeated!")) or string.find(line, "You succumb to your wounds.")) and tablelength(self.EndLines) < 2

    if self.EndLines and self.EndLines[cleanedLine] or detectWipe then
        -- [1] Boss ID [2] Boss Name [3] Success
        local EndTemp = self.EndLines[cleanedLine] 

        if detectWipe or self.BossID == EndTemp[1] then 

            local tempData = ReturnBossData(self.InstanceID, self.BossName, self.InstanceTier)
            local FightDuration = Turbine.Engine.GetGameTime() - self.StartTime
            -- We win
            if EndTemp and EndTemp[3] then

                if tempData["FirstCompletion"] < 0 then
                    ChatOutput("<rgb=#f79000>Congratulations on your first successful clear on Tier " .. self.InstanceTier .. " difficulty! You have wiped ".. tempData["Wipes"] .. " times before this completion!")
                end

                if FightDuration < tempData["BestTime"] then
                    ChatOutput("<rgb=#f79000>Completed encounter " .. EndTemp[2] .. " in " .. TimeDeltaToString(FightDuration) .. ", new best time! You have completed this encounter ".. tempData["Completions"] + 1 .. " times on Tier " .. self.InstanceTier .. " difficulty!")
                else
                    ChatOutput("<rgb=#f79000>Completed encounter " .. EndTemp[2] .. " in " .. TimeDeltaToString(FightDuration) .. ", your best time is: ".. TimeDeltaToString(tempData["BestTime"]) .."! You have completed this encounter ".. tempData["Completions"] + 1 .. " times on Tier " .. self.InstanceTier .. " difficulty!")
                end
                SaveBossData(self.InstanceID, EndTemp[2], self.InstanceTier, FightDuration, true)
            end

            -- We Lost
            if detectWipe or not(EndTemp[3]) and FightDuration > 5 then
                ChatOutput("<rgb=#f79000>Wiped after " .. TimeDeltaToString(FightDuration) .. ", you have wiped " .. tempData["Wipes"] + 1 .. " times on Tier " .. self.InstanceTier .. " difficulty.")
                SaveBossData(self.InstanceID, self.BossName, self.InstanceTier, FightDuration, false)
            end
            
            if combatTimer then
                combatTimer:ChangeMode(false)
            end
            self.InFight = false
        end
    end
end

function FightHandler:FightStatus()
    return self.InFight
end

--[[
    
    Gultháva, Maiden of the Gladden shouts, ''You must prove you are strong enough to triumph over the shadows below.''
    Gultháva, Maiden of the Gladden shouts, ''You are indeed strong. Please, help me remove the shadows that corrupt this place.''
]]